package javax.imageio.stream;

import java.io.IOException;
import java.nio.ByteOrder;
import java.io.Closeable;
import java.io.DataInput;

public interface ImageInputStream extends DataInput, Closeable
{
    public abstract void setByteOrder(ByteOrder p0);
    
    public abstract ByteOrder getByteOrder();
    
    public abstract int read() throws IOException;
    
    public abstract int read(byte[] p0) throws IOException;
    
    public abstract int read(byte[] p0, int p1, int p2) throws IOException;
    
    public abstract void readBytes(IIOByteBuffer p0, int p1) throws IOException;
    
    public abstract boolean readBoolean() throws IOException;
    
    public abstract byte readByte() throws IOException;
    
    public abstract int readUnsignedByte() throws IOException;
    
    public abstract short readShort() throws IOException;
    
    public abstract int readUnsignedShort() throws IOException;
    
    public abstract char readChar() throws IOException;
    
    public abstract int readInt() throws IOException;
    
    public abstract long readUnsignedInt() throws IOException;
    
    public abstract long readLong() throws IOException;
    
    public abstract float readFloat() throws IOException;
    
    public abstract double readDouble() throws IOException;
    
    public abstract String readLine() throws IOException;
    
    public abstract String readUTF() throws IOException;
    
    public abstract void readFully(byte[] p0, int p1, int p2) throws IOException;
    
    public abstract void readFully(byte[] p0) throws IOException;
    
    public abstract void readFully(short[] p0, int p1, int p2) throws IOException;
    
    public abstract void readFully(char[] p0, int p1, int p2) throws IOException;
    
    public abstract void readFully(int[] p0, int p1, int p2) throws IOException;
    
    public abstract void readFully(long[] p0, int p1, int p2) throws IOException;
    
    public abstract void readFully(float[] p0, int p1, int p2) throws IOException;
    
    public abstract void readFully(double[] p0, int p1, int p2) throws IOException;
    
    public abstract long getStreamPosition() throws IOException;
    
    public abstract int getBitOffset() throws IOException;
    
    public abstract void setBitOffset(int p0) throws IOException;
    
    public abstract int readBit() throws IOException;
    
    public abstract long readBits(int p0) throws IOException;
    
    public abstract long length() throws IOException;
    
    public abstract int skipBytes(int p0) throws IOException;
    
    public abstract long skipBytes(long p0) throws IOException;
    
    public abstract void seek(long p0) throws IOException;
    
    public abstract void mark();
    
    public abstract void reset() throws IOException;
    
    public abstract void flushBefore(long p0) throws IOException;
    
    public abstract void flush() throws IOException;
    
    public abstract long getFlushedPosition();
    
    public abstract boolean isCached();
    
    public abstract boolean isCachedMemory();
    
    public abstract boolean isCachedFile();
    
    public abstract void close() throws IOException;
}
